      SUBROUTINE ZF11D(F,A,B,EPS,NDIG,ITMAX,ROOT,IERR)
      INTEGER NDIG,ITMAX,IERR,IC,NSIG
      DOUBLE PRECISION F,A,B,EPS,ROOT,FXL,FXR,FXAPP,EPSP,XL,
     1XR,XAPP,DABS,XMIN
      DATA  XMIN/9.D-18/
      XL=A
      XR=B
      NSIG=NDIG
      IERR=0
      IC=0
      IF(NDIG.EQ.0.AND.EPS.EQ.0.D0) NSIG=5
      EPSP=10.0D0**(-NSIG)
      FXL=F(XL)
      FXR=F(XR)
      XAPP=XL
      IF(FXL*FXR) 3,2,1
    1 IERR=66
      GO TO 8
    2 XAPP=XR
      IF(FXL.EQ.0.0D0) XAPP=XL
      GO TO 8
    3 IF(DABS(FXL-FXR).LE.XMIN) GO TO 8
      XAPP=XL+FXL*(XR-XL)/(FXL-FXR)
      FXAPP=F(XAPP)
      IF(DABS(FXAPP).GT.DABS(EPS)) GO TO 4
      GO TO 8
    4 IF(FXAPP*FXL.GT.0.0D0) GO TO 5
      XR=XAPP
      FXR=FXAPP
      GO TO 6
    5 XL=XAPP
      FXL=FXAPP
    6 IF(NSIG.EQ.0) GO TO 7
      IF(XR-XL.GT.EPSP*DABS(XR)) GO TO 7
      GO TO 8
    7 IC=IC+1
      IF(IC.LE.ITMAX) GO TO 3
      IERR=65
    8 ITMAX=IC
      IF(IERR.NE.0) GO TO 9
      ROOT=XAPP
      GO TO 10
    9 CONTINUE
      CALL UTZF11(IERR,11)
   10 RETURN
      END
